Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_authentication.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_authentication.rst	(revision 5350)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_authentication.rst	(revision 5350)
@@ -0,0 +1,5 @@
+`waeup.sirp.authentication` -- Main application object
+******************************************************
+
+.. automodule:: waeup.sirp.authentication
+   :members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_catalog.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_catalog.rst	(revision 5350)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_catalog.rst	(revision 5350)
@@ -0,0 +1,5 @@
+`waeup.sirp.catalog` -- Cataloging Components
+*********************************************
+
+.. automodule:: waeup.sirp.catalog
+   :members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_datacenter.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_datacenter.rst	(revision 5350)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_datacenter.rst	(revision 5350)
@@ -0,0 +1,5 @@
+`waeup.sirp.datacenter` -- The SIRP datacenter
+**********************************************
+
+.. automodule:: waeup.sirp.datacenter
+   :members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_interfaces.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_interfaces.rst	(revision 5350)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_interfaces.rst	(revision 5350)
@@ -0,0 +1,5 @@
+`waeup.sirp.interfaces` - Main interfaces for SIRP components
+*************************************************************
+
+.. automodule:: waeup.sirp.interfaces
+   :members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_permissions.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_permissions.rst	(revision 5350)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_permissions.rst	(revision 5350)
@@ -0,0 +1,5 @@
+`waeup.sirp.permissions` -- Permissions and Roles
+*************************************************
+
+.. automodule:: waeup.sirp.permissions
+   :members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_tables.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_tables.rst	(revision 5350)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_tables.rst	(revision 5350)
@@ -0,0 +1,5 @@
+`waeup.sirp.tables` -- Autogenerated tables for containers
+**********************************************************
+
+.. automodule:: waeup.sirp.tables
+   :members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_users.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_users.rst	(revision 5350)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_users.rst	(revision 5350)
@@ -0,0 +1,5 @@
+`waeup.sirp.users` -- Users (Principals) and Related
+****************************************************
+
+.. automodule:: waeup.sirp.users
+   :members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_workflow.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_workflow.rst	(revision 5350)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_workflow.rst	(revision 5350)
@@ -0,0 +1,5 @@
+`waeup.sirp.workflow` -- Workflows for `waeup.sirp` objects
+***********************************************************
+
+.. automodule:: waeup.sirp.workflow
+   :members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/index.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/index.rst	(revision 5349)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/index.rst	(revision 5350)
@@ -8,2 +8,10 @@
 
    api_app
+   api_authentication
+   api_catalog
+   api_datacenter
+   api_interfaces
+   api_permissions
+   api_tables
+   api_users
+   api_workflow