Index: /main/waeup.sirp/branches/henrik-contactforms/src/waeup/sirp/accesscodes/browser.txt
===================================================================
--- /main/waeup.sirp/branches/henrik-contactforms/src/waeup/sirp/accesscodes/browser.txt	(revision 5427)
+++ /main/waeup.sirp/branches/henrik-contactforms/src/waeup/sirp/accesscodes/browser.txt	(revision 5428)
@@ -54,5 +54,5 @@
 
     >>> browser.open('http://localhost/myuniversity')
-    >>> browser.getLink('Manage access-codes').click()
+    >>> browser.getLink('Access Codes').click()
     >>> print browser.contents
     <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
Index: /main/waeup.sirp/branches/henrik-contactforms/src/waeup/sirp/app.py
===================================================================
--- /main/waeup.sirp/branches/henrik-contactforms/src/waeup/sirp/app.py	(revision 5427)
+++ /main/waeup.sirp/branches/henrik-contactforms/src/waeup/sirp/app.py	(revision 5428)
@@ -83,5 +83,12 @@
             plugin.setup(self, name, self.logger)
         return
-        
+
+    def updatePlugins(self):
+        """Lookup all plugins and call their `update()` method.
+        """
+        for name, plugin in getUtilitiesFor(IWAeUPSIRPPluggable):
+            plugin.update(self, name, self.logger)
+        return
+
     def _setupLogger(self, logger):
         """Setup general application logger.
Index: /main/waeup.sirp/branches/henrik-contactforms/src/waeup/sirp/browser/pages.py
===================================================================
--- /main/waeup.sirp/branches/henrik-contactforms/src/waeup/sirp/browser/pages.py	(revision 5427)
+++ /main/waeup.sirp/branches/henrik-contactforms/src/waeup/sirp/browser/pages.py	(revision 5428)
@@ -142,4 +142,11 @@
         return
 
+    @grok.action('Update plugins', validator=NullValidator)
+    def updatePlugins(self, **data):
+        self.context.updatePlugins()
+        self.flash('Plugins were updated. See log file for details.')
+        self.redirect(self.url(self.context))
+        return
+
 class AdministrationPage(WAeUPPage):
     """ The administration overview page.
@@ -340,9 +347,13 @@
         msg = MIMEText(text % (fullname,regno,descr))
         msg['From'] = '%s <%s>' % (fullname,email)
-        msg['To'] = 'henrik@waeup.org'
+        
+        # These parameters should be part of the portal configuration.
+        msg['To'] = 'contact@waeup.org'
         msg['Subject'] = 'WAeUP Contact'
-        server = smtplib.SMTP('smtp.scientific-african.org')
-        server.login('henrik@scientific-african.org','kwamekofi')
-        server.sendmail(email,'henrik@waeup.org',msg.as_string())
+        #server = smtplib.SMTP('smtp_server')
+        #server.login('user_name','secret_password')
+        server = smtplib.SMTP('localhost')
+        server.sendmail(email,'contact@waeup.org',msg.as_string())
+        
         server.quit()
         self.flash('Your message has been sent.')
Index: /main/waeup.sirp/branches/henrik-contactforms/src/waeup/sirp/jambtables/applicants.py
===================================================================
--- /main/waeup.sirp/branches/henrik-contactforms/src/waeup/sirp/jambtables/applicants.py	(revision 5427)
+++ /main/waeup.sirp/branches/henrik-contactforms/src/waeup/sirp/jambtables/applicants.py	(revision 5428)
@@ -122,5 +122,7 @@
     grok.implements(IApplicantContainer)
 
-class AccessCodePlugin(grok.GlobalUtility):
+class ApplicantsPlugin(grok.GlobalUtility):
+    """A WAeUPSIRPPlugin that creates an applications folder in portal.
+    """
     grok.name('applications')
     grok.implements(IWAeUPSIRPPluggable)
@@ -141,3 +143,2 @@
                     site, ))
         return
-
Index: /main/waeup.sirp/branches/henrik-contactforms/src/waeup/sirp/permissions.txt
===================================================================
--- /main/waeup.sirp/branches/henrik-contactforms/src/waeup/sirp/permissions.txt	(revision 5427)
+++ /main/waeup.sirp/branches/henrik-contactforms/src/waeup/sirp/permissions.txt	(revision 5428)
@@ -11,4 +11,4 @@
     >>> from waeup.sirp.permissions import getRoles
     >>> getRoles()
-    ['waeup.PortalManager', 'waeup.PortalUser']
+    ['waeup.Applicant', 'waeup.PortalManager', 'waeup.PortalUser']
 